# zib -- zzznowman's IRC bot
# Copyright (C) 2006  Fabian Pietsch <fabian@zzznowman.dyndns.org>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# Channel object

package ZIB::Channel;
use strict;
use warnings;
use vars qw($VERSION);

$VERSION = 20060605.1;

sub new($$;%)
{
	my ($class, $name, $attribs) = @_;

	my $self = {
	  name => $name,
	  why  => $$attribs{why},
	  who  => $$attribs{who},
	  want => $$attribs{want} || 0,
	  have => $$attribs{have} || 0
	};
	return bless($self, $class);
}

sub many_new($%@)
{
	my ($class, $attribs, @names) = @_;
	return map { new($class, $_, $attribs) } (@names);
}

sub name($) { return $_[0]->{name}; }

sub why($;$)
{
	my $self = shift;
	if (@_) { $self->{why} = shift; }
	return $self->{why};
}

sub who($;$)
{
	my $self = shift;
	if (@_) { $self->{who} = shift; }
	return $self->{who};
}

sub want($;$)
{
	my $self = shift;
	if (@_) { $self->{want} = shift; }
	return $self->{want};
}

sub have($;$)
{
	my $self = shift;
	if (@_) { $self->{have} = shift; }
	return $self->{have};
}

1;
